package lmntaleditor;


import java.io.File;
import java.util.HashSet;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import lmntaleditor.frame.*;
import lmntaleditor.util.CommonFontUser;

public class FrontEnd {

	static public FrontEnd frontEnd;
	static public MainFrame mainFrame;
	static public StartupFrame sf;

	static public HashSet<CommonFontUser> fontUsers = new HashSet<CommonFontUser>();

	public FrontEnd(){

		frontEnd    = this;

		mainFrame   = new MainFrame();
        mainFrame.editorPanel.firstFileOpen();

		sleep(500);

		FrontEnd.sf.setVisible(false);

        println("(SYSTEM) Ready.");

	}

	static public void exit(){
		if(!mainFrame.editorPanel.closeFile()){return;}
		mainFrame.exit();
		Env.save();
		System.out.println("LMNtal Editor end.");
		System.exit(0);
	}

	static public void println(final String str){
		javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run() {
			mainFrame.toolTab.systemPanel.logPanel.println(str);
		}});
	}

	static public void errPrintln(final String str){
		javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run() {
			mainFrame.toolTab.systemPanel.logPanel.errPrintln(str);
		}});
	}

	static public void printException(final Exception e){
		javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run() {
			mainFrame.toolTab.systemPanel.logPanel.printException(e);
		}});
	}

	static public void sleep(long millis){
		try {
			Thread.sleep(millis);
		} catch (InterruptedException e) {
			FrontEnd.printException(e);
		}
	}

	static public void updateLookAndFeel(){
		try{
			if(Env.get("LookAndFeel").equals("Metal")){
				UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			}else if(Env.get("LookAndFeel").equals("Motif")){
				UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
			}else if(Env.get("LookAndFeel").equals("Windows")){
				UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			}else if(Env.get("LookAndFeel").equals("WindowsClassic")){
				UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel");
			}else if(Env.get("LookAndFeel").equals("SystemDefault")){
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			}
		}catch(Exception e){
			FrontEnd.printException(e);
		}

	}

	static public void addFontUser(CommonFontUser user){
		fontUsers.add(user);
	}

	static public void removeFontUser(CommonFontUser user){
		fontUsers.remove(user);
	}

	static public void loadAllFont(){
		for(CommonFontUser user : fontUsers){
			user.loadFont();
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		new Env();
		FrontEnd.updateLookAndFeel();

		//ƥLookAndFeelΥ顼б
		try{
			FrontEnd.sf = new StartupFrame();
		}catch(Exception e){
			Env.set("LookAndFeel","Metal");
			updateLookAndFeel();
			FrontEnd.sf = new StartupFrame();
		}
		FrontEnd.sf.startEnvSet();

		javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run(){
			try{
				new FrontEnd();
			}catch(Exception e){
				FrontEnd.printException(e);
				e.printStackTrace();
			}
		}});
	}

}