package lmntaleditor.frame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;

import lmntaleditor.*;

public class MainMenuBar extends JMenuBar implements ActionListener {
	
	private JMenu file;
    private JMenuItem iNew;
    private JMenuItem iOpen;
    private JMenuItem iSave;
    private JMenuItem iSaveAs;
    private JMenuItem iExit;

    private JMenu edit;
    private JMenuItem iCopy;
    private JMenuItem iCut;
    private JMenuItem iPaste;
    public  JMenuItem iUndo;
    public  JMenuItem iRedo;
    
    private JMenu run;
    private JMenuItem iLMNtal;
    private JMenuItem iLMNtalg;
    private JMenuItem iUNYO;
    private JMenuItem iSLIM;
    private JMenuItem iSViewer;
    private JMenuItem iMCProfiler;
    private JMenuItem iKill;
    
    private JMenu setting;
    private JMenuItem iCygwinPath;
    private JMenuItem iSlimPath;
    
    private JMenu help;
    private JMenuItem iVersion;

    public MainMenuBar(){
    	
    	file = new JMenu(Lang.m[0]);
        add(file);
        file.setMnemonic(KeyEvent.VK_F);
        
        iNew     = new JMenuItem(Lang.m[1]);
        file.add(iNew);
        iNew.addActionListener(this);
        iNew.setMnemonic(KeyEvent.VK_N);
        iNew.setAccelerator(KeyStroke.getKeyStroke("control N"));
        
        iOpen    = new JMenuItem(Lang.m[2]);
        file.add(iOpen);
        iOpen.addActionListener(this);
        iOpen.setMnemonic(KeyEvent.VK_O);
        iOpen.setAccelerator(KeyStroke.getKeyStroke("control O"));
        
        iSave    = new JMenuItem(Lang.m[3]);
        file.add(iSave);
        iSave.addActionListener(this);
        iSave.setMnemonic(KeyEvent.VK_S);
        iSave.setAccelerator(KeyStroke.getKeyStroke("control S"));
        
        iSaveAs  = new JMenuItem(Lang.m[4]);
        file.add(iSaveAs);
        iSaveAs.addActionListener(this);
        iSaveAs.setMnemonic(KeyEvent.VK_A);
        
        file.addSeparator();
        
        iExit    = new JMenuItem(Lang.m[5]);
        file.add(iExit);
        iExit.addActionListener(this);
        iExit.setMnemonic(KeyEvent.VK_X);
        
        
        edit = new JMenu(Lang.m[6]);
        add(edit);
        edit.setMnemonic(KeyEvent.VK_E);
        
        iUndo = new JMenuItem(Lang.m[16]);
        edit.add(iUndo);
        iUndo.setEnabled(false);
        iUndo.addActionListener(this);
        iUndo.setMnemonic(KeyEvent.VK_U);
        iUndo.setAccelerator(KeyStroke.getKeyStroke("control Z"));
        
        iRedo = new JMenuItem(Lang.m[17]);
        edit.add(iRedo);
        iRedo.setEnabled(false);
        iRedo.addActionListener(this);
        iRedo.setMnemonic(KeyEvent.VK_R);
        iRedo.setAccelerator(KeyStroke.getKeyStroke("control Y"));
        
        edit.addSeparator();
        
        iCopy = new JMenuItem(Lang.m[7]);
        edit.add(iCopy);
        iCopy.addActionListener(this);
        iCopy.setMnemonic(KeyEvent.VK_C);
        iCopy.setAccelerator(KeyStroke.getKeyStroke("control C"));
        
        iCut = new JMenuItem(Lang.m[8]);
        edit.add(iCut);
        iCut.addActionListener(this);
        iCut.setMnemonic(KeyEvent.VK_T);
        iCut.setAccelerator(KeyStroke.getKeyStroke("control X"));
        
        iPaste = new JMenuItem(Lang.m[9]);
        edit.add(iPaste);
        iPaste.addActionListener(this);
        iPaste.setMnemonic(KeyEvent.VK_P);
        iPaste.setAccelerator(KeyStroke.getKeyStroke("control V"));
        
        
        run = new JMenu(Lang.m[10]);
        add(run);
        run.setMnemonic(KeyEvent.VK_R);
        
        iLMNtal = new JMenuItem(Lang.m[11]);
        run.add(iLMNtal);
        iLMNtal.addActionListener(this);
        iLMNtal.setMnemonic(KeyEvent.VK_L);
        iLMNtal.setAccelerator(KeyStroke.getKeyStroke("F1"));
        
        iLMNtalg = new JMenuItem(Lang.m[12]);
        run.add(iLMNtalg);
        iLMNtalg.addActionListener(this);
        iLMNtalg.setMnemonic(KeyEvent.VK_G);
        iLMNtalg.setAccelerator(KeyStroke.getKeyStroke("F2"));
        
        iUNYO = new JMenuItem(Lang.m[13]);
        run.add(iUNYO);
        iUNYO.addActionListener(this);
        iUNYO.setMnemonic(KeyEvent.VK_U);
        iUNYO.setAccelerator(KeyStroke.getKeyStroke("F3"));
        
        iSLIM = new JMenuItem(Lang.m[14]);
        run.add(iSLIM);
        iSLIM.addActionListener(this);
        iSLIM.setMnemonic(KeyEvent.VK_S);
        iSLIM.setAccelerator(KeyStroke.getKeyStroke("F4"));
        
        iSViewer = new JMenuItem(Lang.m[15]);
        run.add(iSViewer);
        iSViewer.addActionListener(this);
        iSViewer.setMnemonic(KeyEvent.VK_V);
        iSViewer.setAccelerator(KeyStroke.getKeyStroke("F5"));
        
        iMCProfiler = new JMenuItem(Lang.m[21]);
        run.add(iMCProfiler);
        iMCProfiler.addActionListener(this);
        iMCProfiler.setMnemonic(KeyEvent.VK_P);
        
        iKill = new JMenuItem(Lang.m[20]);
        run.add(iKill);
        iKill.addActionListener(this);
        iKill.setMnemonic(KeyEvent.VK_K);
        iKill.setAccelerator(KeyStroke.getKeyStroke("ESCAPE"));
        
        
        setting = new JMenu(Lang.m[22]);
        add(setting);
        setting.setMnemonic(KeyEvent.VK_S);
        
        iCygwinPath = new JMenuItem(Lang.m[23]);
        setting.add(iCygwinPath);
        iCygwinPath.addActionListener(this);
        
        iSlimPath = new JMenuItem(Lang.m[24]);
        setting.add(iSlimPath);
        iSlimPath.addActionListener(this);
        
        help = new JMenu(Lang.m[18]);
        add(help);
        help.setMnemonic(KeyEvent.VK_H);
        
        iVersion = new JMenuItem(Lang.m[19]);
        help.add(iVersion);
        iVersion.addActionListener(this);
        
    }
    
    public void updateUndoRedo(boolean undo,boolean redo){
    	iUndo.setEnabled(undo);
		iRedo.setEnabled(redo);
    }

	public void actionPerformed(ActionEvent e) {
		JMenuItem src = (JMenuItem)e.getSource();
		
		if (src == iNew) {
			FrontEnd.mainFrame.editorPanel.newFileOpen();
        }else if(src == iOpen) {
        	FrontEnd.mainFrame.editorPanel.fileOpen();
		}else if(src == iSave) {
        	FrontEnd.mainFrame.editorPanel.fileSave();
        }else if(src == iSaveAs) {
        	FrontEnd.mainFrame.editorPanel.fileSaveAs();
        }else if(src == iExit) {
        	FrontEnd.frontEnd.exit();
        }else if(src == iCopy) {
        	FrontEnd.mainFrame.editorPanel.editor.copy();
        }else if(src == iCut) {
        	FrontEnd.mainFrame.editorPanel.editor.cut();
        }else if(src == iPaste) {
        	FrontEnd.mainFrame.editorPanel.editor.paste();
        }else if(src == iUndo) {
        	FrontEnd.mainFrame.editorPanel.editorUndo();
        }else if(src == iRedo) {
        	FrontEnd.mainFrame.editorPanel.editorRedo();
        }else if(src == iLMNtal) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.lmntalButton.doClick();
        }else if(src == iLMNtalg) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.lmntalgButton.doClick();
        }else if(src == iUNYO) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.unyoButton.doClick();
        }else if(src == iSLIM) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.slimButton.doClick();
        }else if(src == iSViewer) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.sviewerButton.doClick();
        }else if(src == iKill) {
        	FrontEnd.mainFrame.editorPanel.buttonPanel.killButton.doClick();
        }else if(src == iCygwinPath) {
        	new CygwinPathSettingFrame();
        }else if(src == iSlimPath) {
        	new SlimPathSettingFrame();
        }else if(src == iVersion) {
        	JOptionPane.showMessageDialog(
        			FrontEnd.mainFrame,
        			"LMNtalEditor\n"+
        			"Version : "+Env.APP_VERSION+"\n"+
        			"Date : "+Env.APP_DATE+"\n",
        			"LMNtalEditor",
        		JOptionPane.PLAIN_MESSAGE
        	);
        }
		
	}
	
}
