package lmntaleditor.frame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.io.File;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

import lmntaleditor.Env;
import lmntaleditor.FrontEnd;
import lmntaleditor.Lang;
import lmntaleditor.runner.Ltl2baInstaller;
import lmntaleditor.runner.SlimInstaller;

public class StartupFrame extends JFrame {

	public StartupFrame(){

		ImageIcon image = new ImageIcon(Env.getImageOfFile("img/logo.gif"));

		//setSize(image.getIconWidth()+30, image.getIconHeight()+30);
	    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	    setUndecorated(true);
	    setIconImage(Env.getImageOfFile("img/icon.gif"));

	    JPanel panel = new JPanel();
		//panel.setBorder(new LineBorder(new Color(200,200,200), 2, true));
		panel.setBackground(new Color(255,255,255));
		panel.setLayout(new BorderLayout());
		add(panel);

		JLabel icon = new JLabel(image);
		panel.add(icon,BorderLayout.CENTER);

		JTextField text = new JTextField("Version "+Env.APP_VERSION);
		text.setHorizontalAlignment(JTextField.CENTER);
		text.setBackground(new Color(255,255,255));
		text.setEditable(false);
	    text.setBorder(null);
	    panel.add(text,BorderLayout.SOUTH);

	    pack();
	    setLocationRelativeTo(null);
	    setVisible(true);

	}

	LangSettingFrame langFrame;
	SlimPathSettingFrame slimFrame;
	CygwinPathSettingFrame cygwinFrame;

	public void startEnvSet(){

		if((Env.get("LANG")==null||Env.get("LANG").equals(""))){
			javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run(){
				langFrame = new LangSettingFrame();
			}});
			while(langFrame==null||langFrame.isDisplayable()){
				FrontEnd.sleep(200);
			}
		}

		Lang.set(Env.get("LANG"));

		if(File.pathSeparatorChar==';'&&(Env.get("WINDOWS_CYGWIN_DIR")==null||Env.get("WINDOWS_CYGWIN_DIR").equals(""))){
			javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run(){
				cygwinFrame = new CygwinPathSettingFrame();
			}});
			while(cygwinFrame==null||cygwinFrame.isDisplayable()){
				FrontEnd.sleep(200);
			}
		}

		if(Env.get("SLIM_EXE_PATH")==null||Env.get("SLIM_EXE_PATH").equals("")){
			javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run(){
				slimFrame = new SlimPathSettingFrame();
			}});
			while(slimFrame==null||!slimFrame.isEnd()){
				FrontEnd.sleep(200);
			}
		}

		if(Env.get("SLIM_EXE_PATH")==null||Env.get("SLIM_EXE_PATH").equals("")){
			javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run(){
				slimFrame = new SlimPathSettingFrame();
			}});
			while(slimFrame==null||!slimFrame.isEnd()){
				FrontEnd.sleep(200);
			}
		}
	}

}