package lmntaleditor.frame;

import java.awt.Dimension;

import javax.swing.JTabbedPane;

import lmntaleditor.ltl.LtlPanel;
import lmntaleditor.mcprofiler.MCProfilePanel;
import lmntaleditor.option.OptionPanel;
import lmntaleditor.stateviewer.StatePanel;
import lmntaleditor.system.SystemPanel;

public class ToolTab extends JTabbedPane {

	public SystemPanel systemPanel;
	public LtlPanel ltlPanel;
	public StatePanel statePanel;
	public OptionPanel optionPanel;
	public MCProfilePanel mcprofilePanel;
	
	public ToolTab(){
		setMinimumSize(new Dimension(0,0));
		setFocusable(false);
		
		systemPanel = new SystemPanel();
		addTab("System", systemPanel);
		
		ltlPanel = new LtlPanel();
		addTab("LTL Model Check", ltlPanel);
		
		statePanel = new StatePanel();
		addTab("StateViewer", statePanel);
		
		mcprofilePanel = new MCProfilePanel();
		addTab("MCProfiler", mcprofilePanel);
		
		optionPanel = new OptionPanel();
		addTab("Option", optionPanel);
		
	}
	
	public void setTab(String tab){
		if(tab.equals("System")){
			setSelectedComponent(systemPanel);
		}else if(tab.equals("StateViewer")){
			setSelectedComponent(statePanel);
		}else if(tab.equals("MCProfiler")){
			setSelectedComponent(mcprofilePanel);
		}
	}
	
}
