package lmntaleditor.option;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import lmntaleditor.*;
import lmntaleditor.util.FixFlowLayout;

public class EditorColorPanel extends JPanel implements ActionListener{
	String majorOption[] = {"comment","symbol","reserved"};
	JCheckBox optionCheckBox[] = new JCheckBox[majorOption.length];
	
	EditorColorPanel(){
		
		setLayout(new FixFlowLayout());
		setBorder(new TitledBorder("Color"));
		
		for(int i=0;i<majorOption.length;++i){
			optionCheckBox[i] = new JCheckBox(majorOption[i]);
			add(optionCheckBox[i]);
		}
		settingInit();
		
		for(int i=0;i<majorOption.length;++i){
			optionCheckBox[i].addActionListener(this);
		}
	}
	
	void settingInit(){
		for(int i=0;i<majorOption.length;++i){
			optionCheckBox[i].setSelected(false);
		}
		String[] options = Env.get("COLOR_TARGET").split(" ");
		for(String o : options){
			for(int i=0;i<majorOption.length;++i){
				if(majorOption[i].equals(o)){
					optionCheckBox[i].setSelected(true);
				}
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		String newOptions = "";
		for(int i=0;i<majorOption.length;++i){
			if(optionCheckBox[i].isSelected()){
				if(newOptions.length()==0){
					newOptions += optionCheckBox[i].getText();
				}else{
					newOptions += " " + optionCheckBox[i].getText();
				}
			}
		}
		Env.set("COLOR_TARGET",newOptions);
		FrontEnd.mainFrame.editorPanel.doc.colorUpdate();
	}
}
