package lmntaleditor.option;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import lmntaleditor.Env;
import lmntaleditor.util.FixFlowLayout;

public class EncodingSettingPanel extends JPanel implements ActionListener{

	String encodingList[] = {"SJIS", "EUC_JP","ISO2022JP", "UTF8"};

	JComboBox readComboBox;
	JComboBox writeComboBox;

	EncodingSettingPanel(){

		setLayout(new FixFlowLayout());
		setBorder(new TitledBorder("File Encoding"));

		add(new JLabel("READ"));
		readComboBox = new JComboBox(encodingList);
		add(readComboBox);

		add(new JLabel("WRITE"));
		writeComboBox = new JComboBox(encodingList);
		add(writeComboBox);

		settingInit();

		readComboBox.addActionListener(this);
		writeComboBox.addActionListener(this);

	}

	void settingInit(){
		for(String str : encodingList){
			if(str.equals(Env.get("EDITER_FILE_READ_ENCODING"))){
				readComboBox.setSelectedItem(str);
				break;
			}
		}
		for(String str : encodingList){
			if(str.equals(Env.get("EDITER_FILE_WRITE_ENCODING"))){
				writeComboBox.setSelectedItem(str);
				break;
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		Env.set("EDITER_FILE_READ_ENCODING",(String)readComboBox.getSelectedItem());
		Env.set("EDITER_FILE_WRITE_ENCODING",(String)writeComboBox.getSelectedItem());
	}

}
