package lmntaleditor.option;

import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import lmntaleditor.*;
import lmntaleditor.util.FixFlowLayout;

public class FontSettingPanel extends JPanel implements ActionListener{

	String fontFamilyList[] = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
	String fontSizeList[] = {"8","9","10","11","12","14","16","18","20","24","28","32","36","40","44","48","54","60","66","72","80","88","96","106"};
	String tabSizeList[] = {"1","2","3","4","5","6","7","8","9","10"};


	JComboBox fontFamilyComboBox;
	JComboBox fontSizeComboBox;
	JComboBox tabSizeComboBox;

	FontSettingPanel(){

		setLayout(new FixFlowLayout());
		setBorder(new TitledBorder("Font & Language"));

		add(new JLabel("FontFamily"));
		fontFamilyComboBox = new JComboBox(fontFamilyList);
		add(fontFamilyComboBox);

		add(new JLabel("FontSize"));
		fontSizeComboBox = new JComboBox(fontSizeList);
		add(fontSizeComboBox);

		add(new JLabel("TabSize"));
		tabSizeComboBox = new JComboBox(tabSizeList);
		add(tabSizeComboBox);

		settingInit();

		fontFamilyComboBox.addActionListener(this);
		fontSizeComboBox.addActionListener(this);
		tabSizeComboBox.addActionListener(this);

	}

	void settingInit(){
		for(String str : fontFamilyList){
			if(str.equals(Env.get("EDITER_FONT_FAMILY"))){
				fontFamilyComboBox.setSelectedItem(str);
				break;
			}
		}
		for(String str : fontSizeList){
			if(str.equals(Env.get("EDITER_FONT_SIZE"))){
				fontSizeComboBox.setSelectedItem(str);
				break;
			}
		}
		for(String str : tabSizeList){
			if(str.equals(Env.get("EDITER_TAB_SIZE"))){
				tabSizeComboBox.setSelectedItem(str);
				break;
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		Env.set("EDITER_FONT_FAMILY",(String)fontFamilyComboBox.getSelectedItem());
		Env.set("EDITER_FONT_SIZE",(String)fontSizeComboBox.getSelectedItem());
		Env.set("EDITER_TAB_SIZE",(String)tabSizeComboBox.getSelectedItem());
		/*
		FrontEnd.mainFrame.editorPanel.loadFont();
		FrontEnd.mainFrame.toolTab.systemPanel.logPanel.loadFont();
		FrontEnd.mainFrame.toolTab.systemPanel.outputPanel.loadFont();
		FrontEnd.mainFrame.toolTab.statePanel.stateGraphPanel.loadFont();
		*/
		FrontEnd.loadAllFont();

	}

}

