package lmntaleditor.option;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.TitledBorder;

import lmntaleditor.Env;
import lmntaleditor.FrontEnd;
import lmntaleditor.Lang;
import lmntaleditor.util.FixFlowLayout;

public class GeneralSettingPanel  extends JPanel implements ActionListener{

	String langList[] = {"jp","en"};
	String lookAndFeelList[] = {"Metal","Motif","Windows","WindowsClassic","SystemDefault"};
	
	JComboBox lookAndFeelComboBox;
	JComboBox langComboBox;

	GeneralSettingPanel(){

		setLayout(new FixFlowLayout());
		setBorder(new TitledBorder("General"));

		add(new JLabel("Lang"));
		langComboBox = new JComboBox(langList);
		add(langComboBox);
		
		add(new JLabel("LookAndFeel"));
		lookAndFeelComboBox = new JComboBox(lookAndFeelList);
		add(lookAndFeelComboBox);

		settingInit();
		
		lookAndFeelComboBox.addActionListener(this);
		langComboBox.addActionListener(this);

	}

	void settingInit(){
		for(String str : lookAndFeelList){
			if(str.equals(Env.get("LookAndFeel"))){
				lookAndFeelComboBox.setSelectedItem(str);
				break;
			}
		}
		for(String str : langList){
			if(str.equals(Env.get("LANG"))){
				langComboBox.setSelectedItem(str);
				break;
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==langComboBox){
			Env.set("LANG",(String)langComboBox.getSelectedItem());
			JOptionPane.showMessageDialog(FrontEnd.mainFrame,Lang.f[4],"Change Language",JOptionPane.PLAIN_MESSAGE);
		}else{
			Env.set("LookAndFeel",(String)lookAndFeelComboBox.getSelectedItem());
			FrontEnd.updateLookAndFeel();
			SwingUtilities.updateComponentTreeUI(FrontEnd.mainFrame);
		}
	}

}
