package lmntaleditor.runner;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import lmntaleditor.*;

public class Ltl2baRunner {

	private ThreadRunner runner;
	private StringBuffer buffer;

	private String ltl;
	private boolean success;

	public Ltl2baRunner(String ltl){
		this.ltl = ltl.trim();
		this.runner = new ThreadRunner();
		this.buffer = new StringBuffer();
		this.success = false;
	}

	public void run() {
		runner.start();
	}

	public String getOutput(){
		return buffer.toString();
	}

	public boolean isRunning() {
		if(runner==null) return false;
		return true;
	}

	public void exit(){
		runner=null;
	}

	public boolean isSuccess(){
		return success;
	}

	private class ThreadRunner extends Thread {

		private Process p;

		public void run() {
			try {

				ArrayList<String> cmdlist = new ArrayList<String>();
				cmdlist.add("lmntal"+File.separator+Env.LTL2BA_DIR_NAME+File.separator+Env.getLtl2baBinaryName());
				cmdlist.add("-f");
				cmdlist.add("!("+ltl+")");

				ProcessBuilder pb = new ProcessBuilder(cmdlist);
				Env.setProcessEnvironment(pb.environment());
				pb.redirectErrorStream(true);
				p = pb.start();
				BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));

				String str;
				while ((str=in.readLine())!=null) {
					buffer.append(str+"\n");
				}

				in.close();
				p.waitFor();

				success = true;

			}catch(Exception e){

				StringWriter sw = new StringWriter();
			    e.printStackTrace(new PrintWriter(sw));
			    buffer.append(sw.toString());

			}finally{
				exit();
			}
		}

	}

}
