package lmntaleditor.stateviewer;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import lmntaleditor.*;
import lmntaleditor.util.CommonFontUser;
import lmntaleditor.util.FixFlowLayout;

public class StateControlPanel extends JPanel implements ChangeListener,ActionListener,CommonFontUser {

	private StatePanel statePanel;

	/*
	private JPanel control = new JPanel();
	private JButton delete = new JButton("Delete");
    private JButton reset = new JButton("All Reset");
    */

	private JPanel matchPanel = new JPanel();
	private JLabel matchLabel = new JLabel();
	private JPanel matchHeadPanel = new JPanel();
	private JTextField matchHeadField = new JTextField();
	private JPanel matchGuardPanel = new JPanel();
	private JTextField matchGuardField = new JTextField();
    private JButton matchButton = new JButton("Match");

	private JPanel findPanel = new JPanel();
	private JLabel findLabel = new JLabel();
	private JTextField findField = new JTextField();
    private JButton findButton = new JButton("Find");

    private JSlider zoomSlider = new JSlider(1,39);

	StateControlPanel(StatePanel statePanel){

		this.statePanel = statePanel;
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));

		/*
		delete.setFocusable(false);
		delete.addActionListener(this);
		control.add(delete);

		dot.setFocusable(false);
		dot.addActionListener(this);
		control.add(dot);

		reset.setFocusable(false);
		reset.addActionListener(this);
		control.add(reset);

		add(control);
		*/

		matchButton.addActionListener(this);
		matchHeadField.addActionListener(this);
		matchGuardField.addActionListener(this);
		matchHeadPanel.setLayout(new BorderLayout());
		matchHeadPanel.add(new JLabel(" Head:"),BorderLayout.WEST);
		matchHeadPanel.add(matchHeadField, BorderLayout.CENTER);
		matchGuardPanel.setLayout(new BorderLayout());
		matchGuardPanel.add(new JLabel(" Guard:"),BorderLayout.WEST);
		matchGuardPanel.add(matchGuardField, BorderLayout.CENTER);
		JPanel l = new JPanel(new GridLayout(1,2));
		l.add(matchHeadPanel);
		l.add(matchGuardPanel);
		matchPanel.setLayout(new BorderLayout());
		matchPanel.add(matchLabel,BorderLayout.WEST);
		matchPanel.add(l, BorderLayout.CENTER);
		matchPanel.add(matchButton, BorderLayout.EAST);
		matchPanel.setVisible(Env.is("SV_MATCH"));
		add(matchPanel);


		findButton.addActionListener(this);
		findField.addActionListener(this);
		findPanel.setLayout(new BorderLayout());
		findPanel.add(findLabel,BorderLayout.WEST);
		findPanel.add(findField, BorderLayout.CENTER);
		findPanel.add(findButton, BorderLayout.EAST);
		findPanel.setVisible(Env.is("SV_FIND"));
		add(findPanel);

		zoomSlider.addChangeListener(this);
		add(zoomSlider);

		allButtonSetEnabled(false);

		loadFont();
		FrontEnd.addFontUser(this);
	}

	public void loadFont(){
		Font font = new Font(Env.get("EDITER_FONT_FAMILY"), Font.PLAIN, Env.getInt("EDITER_FONT_SIZE"));
		matchHeadField.setFont(font);
		matchGuardField.setFont(font);
		findField.setFont(font);
		revalidate();
	}

	public void allButtonSetEnabled(boolean enabled){
		matchHeadField.setEnabled(enabled);
		matchGuardField.setEnabled(enabled);
		matchButton.setEnabled(enabled);
		findField.setEnabled(enabled);
		findButton.setEnabled(enabled);
		zoomSlider.setEnabled(enabled);
	}

	public void toggleMatchVisible(){
		matchPanel.setVisible(!matchPanel.isVisible());
		Env.set("SV_MATCH",matchPanel.isVisible());
	}

	public void toggleFindVisible(){
		findPanel.setVisible(!findPanel.isVisible());
		Env.set("SV_FIND",findPanel.isVisible());
	}

	public void setSliderPos(double z){
		int pos = (int)(Math.sqrt(z*100)*2-1);
		//int zoom = (int)(z*10);
		if(pos<1){ pos=1; }else if(pos>39){ pos=39; }
		zoomSlider.removeChangeListener(this);
		zoomSlider.setValue(pos);
		zoomSlider.addChangeListener(this);
	}

	public void stateChanged(ChangeEvent e) {
		double z = (zoomSlider.getValue()+1)/2.0;
		statePanel.stateGraphPanel.setSliderZoom(z*z/100.0);
	}

	public void actionPerformed(ActionEvent e) {
		Object src = e.getSource();

		if(src==matchButton||src==matchHeadField||src==matchGuardField){
			matchLabel.setText("matching...");
			(new Thread(new Runnable() { public void run() {
				final int match = statePanel.stateGraphPanel.stateMatch(matchHeadField.getText(),matchGuardField.getText());
				javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run() {
					if(match>=0){
						matchLabel.setText(" match : "+match+" state ");
					}else{
						matchLabel.setText(" error! ");
					}
				}});
			}})).start();
		}else if(src==findButton||src==findField){
			findLabel.setText("finding...");
			(new Thread(new Runnable() { public void run() {
				final int match = statePanel.stateGraphPanel.stateFind(findField.getText());
				javax.swing.SwingUtilities.invokeLater(new Runnable(){public void run() {
					findLabel.setText(" \""+findField.getText()+"\" match : "+match+" state ");
				}});
			}})).start();
		}
	}

}
