package lmntaleditor.stateviewer;

import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;

import lmntaleditor.FrontEnd;
import lmntaleditor.stateviewer.StateNode.ColorMode;

public class StateNodeSet {
	private StateNode startNode;
	private ArrayList<StateNode> endNode =  new ArrayList<StateNode>();
	private HashMap<Long,StateNode> allNode = new HashMap<Long,StateNode>();
	private ArrayList<ArrayList<StateNode>> depthNode = new ArrayList<ArrayList<StateNode>>();
	private ArrayList<StateNode> drawOrder = new ArrayList<StateNode>();
	private ArrayList<StateNode> cycleNode = new ArrayList<StateNode>();
	private StateNode acceptStartNode;

	final String initString = "init:";

	public boolean setSlimNdResult(String str){
		int line=0;

		String[] strs = str.split("\n");

		// initõ
		for(;line<strs.length;++line){
			if(strs[line].startsWith(initString)) break;
		}

		//顼
		if(line>=strs.length) return false;

		int start = Integer.parseInt(strs[line].substring(initString.length()));
		int ls = line;

		for(line++;line<strs.length;++line){
			//ܤ
			String ss[] = strs[line].split("::",3);
			if(ss.length<3){ continue; }

			long id = Long.parseLong(ss[0]);
			StateNode node = new StateNode(id,line-ls,ss[1], ss[2]);
			allNode.put(id,node);
			if(id==start){
				startNode = node;
			}
			if(ss[1].equals("")){
				endNode.add(node);
			}
		}

		//顼
		if(startNode==null) return false;

		setNodeFrom();
		setTreeDepth();
		updateNodeLooks();
		resetOrder();

		return true;
	}

	public boolean setSlimLtlResult(String str){
		int line=0;
		ArrayList<Long> cycles = new ArrayList<Long>();
		HashSet<Long> accepts = new HashSet<Long>();

		String[] strs = str.split("\n");

		// initõ
		int findCycle = 0;
		for(;line<strs.length;++line){

			String ss[] = strs[line].split(":",3);

			//cycleξ֤
			//if(ss.length==3&&findCycle<=1&&ss[0].length()>0&&ss[0].charAt(0)!='*'){
			if(ss.length==3&&findCycle<=1){

				long id = Integer.parseInt(ss[2].trim());
				cycles.add(id);
				if(ss[1].toLowerCase().indexOf("accept")!=-1){
					accepts.add(id);
				}

				findCycle=1;
			}else if(findCycle==1){
				findCycle=2;
			}

			if(strs[line].startsWith(initString)) break;
		}

		//顼
		if(line>=strs.length) return false;

		long start = Long.parseLong(strs[line].substring(initString.length()));
		int ls = line;

		for(line++;line<strs.length;++line){
			//ܤ
			String ss[] = strs[line].split("::",3);
			if(ss.length<3){ break; }

			long id = Long.parseLong(ss[0]);
			StateNode node = new StateNode(id,line-ls,ss[1], ss[2]);
			allNode.put(id,node);
			if(id==start){
				startNode = node;
			}
			if(ss[1].equals("")){
				endNode.add(node);
			}

			if(cycles.contains(id)){
				if(accepts.contains(id)){
					node.setColorMode(ColorMode.em);
				}else{
					node.setColorMode(ColorMode.normal);
				}
			}else{
				node.setColorMode(ColorMode.weak);
			}
		}

		for(line++;line<strs.length;++line){
			//̾
			String ss[] = strs[line].split("::",2);
			if(ss.length<2){ break; }

			long id = Integer.parseInt(ss[0]);
			StateNode node = allNode.get(id);
			if(node==null){ break; }

			if(ss[1].toLowerCase().indexOf("accept")!=-1){
				node.setAccept(true);
			}
		}

		//顼
		if(startNode==null) return false;

		setNodeFrom();
		setTreeDepth();
		updateNodeLooks();
		resetOrder();

		for(Long id : cycles){
			StateNode node = allNode.get(id);
			cycleNode.add(node);
			setOrderEnd(node);
		}

		//acceptance򸫤Ĥ
		if(cycleNode.size()>0){
			int minI = -1;
			for(StateNode to: cycleNode.get(cycleNode.size()-1).getToNodes()){
				if(to.isAccept()){
					int i = cycleNode.indexOf(to);
					if(minI<i) acceptStartNode=to;
				}
			}
		}
		return true;
	}

	public String getDotString(){
		StringBuffer str = new StringBuffer();
		int no=0;
		for(ArrayList<StateNode> sameDepth : depthNode){
			for(StateNode node : sameDepth){
				str.append(node.getStringTo(++no));
			}
		}
		return str.toString();
	}

	public String getRankString(){
		StringBuffer str = new StringBuffer();
		for(ArrayList<StateNode> sameDepth : depthNode){
			str.append("{rank = same");
			for(StateNode node : sameDepth){
				str.append(";"+node.id);
			}
			str.append("}\n");
		}
		return str.toString();
	}

	public String getMatchFileString(String head,String guard){
		StringBuffer str = new StringBuffer();
		for(StateNode node : allNode.values()){
			str.append("{ sVr_id("+node.id+"),"+node.state+" },\n");
		}
		str.append("sVr_matches{}.\n");
		str.append("sVr_matches{$ids},{sVr_id($sVr_n),"+head+"}\n");
		str.append(" :- int($sVr_n)");
		if(!guard.equals("")){ str.append(","+guard); }
		str.append("\n |");
		str.append("sVr_matches{$ids,id($sVr_n)},{"+head+"}\n");
		return str.toString();
	}

	public void reduction(){
		StateNode removenode;
		while((removenode=getToOneFromOne())!=null){
			innerRemove(removenode.id);
		}
		updateNodeLooks();
	}

	public void remove(StateNode node){
		innerRemove(node.id);
		updateNodeLooks();
	}

	public boolean isFlow(StateNode n1,StateNode n2){
		if(cycleNode.size()==0||n1==n2) return true;
		for(int i=0;i<cycleNode.size();++i){
			if(cycleNode.get(i)==n1){
				if(i>0&&cycleNode.get(i-1)==n2) return true;
				if(i<(cycleNode.size()-1)&&cycleNode.get(i+1)==n2) return true;
			}
			if(cycleNode.get(i)==n2){
				if(i>0&&cycleNode.get(i-1)==n1) return true;
				if(i<(cycleNode.size()-1)&&cycleNode.get(i+1)==n1) return true;
			}
		}
		if(n1==acceptStartNode){
			if(n2==cycleNode.get(cycleNode.size()-1)) return true;
		}else if(n2==acceptStartNode){
			if(n1==cycleNode.get(cycleNode.size()-1)) return true;
		}

		return false;
	}

	public StateNode get(int id){
		return allNode.get(id);
	}

	public int getDepth(){
		return depthNode.size();
	}

	public int getSameDepthSize(int depth){
		return depthNode.get(depth).size();
	}

	public int size(){
		return allNode.size();
	}

	public Collection<StateNode> getAllNode(){
		return allNode.values();
	}

	public Collection<StateNode> getAllNodeDrawOrder(){
		return drawOrder;
	}

	public StateNode getStartNode(){
		return startNode;
	}

	public ArrayList<StateNode> getEndNode(){
		return endNode;
	}

	public ArrayList<ArrayList<StateNode>> getDepthNode(){
		return depthNode;
	}

	public void resetOrder(){
		drawOrder.clear();
		for(StateNode node : allNode.values()){
			drawOrder.add(node);
		}
		for(StateNode node : endNode){
			setOrderEnd(node);
		}
	}

	public void setOrderEnd(StateNode node){
		drawOrder.remove(node);
		drawOrder.add(node);
	}

	private StateNode getToOneFromOne(){
	    if(allNode.size()<=1) return null;
		for(StateNode node : allNode.values()){
	    	ArrayList<StateNode> toes = node.getToNodes();
			if(toes.size()==1){
				ArrayList<StateNode> froms = node.getFromNodes();
				if(froms.size()==1){
					if(froms.get(0).getToNodes().size()==1){
						return node;
					}
				}
			}
		}
	    return null;
	}

	private void innerRemove(long removeId){
		StateNode removenode = allNode.get(removeId);

		for(StateNode to : removenode.getToNodes()){
			if(to==removenode){ continue; }
			to.removeFromNode(removenode);
			for(StateNode from : removenode.getFromNodes()){
				to.addFromNode(from);
			}
		}

		for(StateNode from : removenode.getFromNodes()){
			if(from==removenode){ continue; }

			from.removeToNode(removenode);
			for(StateNode to : removenode.getToNodes()){
				from.addToNode(to);
			}
		}

		allNode.remove(removeId);
		drawOrder.remove(removenode);
		if(removenode==startNode){ startNode = null; }
		endNode.remove(removenode);

		ArrayList<StateNode> sameDepth = depthNode.get(removenode.depth);
		sameDepth.remove(removenode);
		for(StateNode node : sameDepth){
			if(node.nth>removenode.nth){
				node.nth--;
			}
		}

		if(sameDepth.size()==0){
			depthNode.remove(removenode.depth);
			for(StateNode node : allNode.values()){
				if(node.depth>removenode.depth){
					node.depth--;
				}
			}
		}
	}

	private void setTreeDepth(){
		allNodeUnMark();
		depthNode.clear();

		LinkedList<StateNode> queue = new LinkedList<StateNode>();

		startNode.mark();
		startNode.depth=0;
		startNode.nth=0;
		depthNode.add(0,new ArrayList<StateNode>());
		depthNode.get(0).add(startNode);
		queue.add(startNode);

		while(!queue.isEmpty()){
			StateNode node = queue.remove();
			for(StateNode child : node.getToNodes()){
				if(child.isMarked()){continue;}
				child.mark();
				child.depth = node.depth+1;
				if(depthNode.size()<=child.depth){
					depthNode.add(child.depth,new ArrayList<StateNode>());
				}
				ArrayList<StateNode> dnodes = depthNode.get(child.depth);
				if(dnodes==null){
					dnodes = new ArrayList<StateNode>();
					depthNode.add(child.depth,dnodes);
				}
				child.nth=dnodes.size();
				dnodes.add(child);
				queue.add(child);
			}
		}
	}

	private void setNodeFrom(){
		for(StateNode node : allNode.values()){
			for(long toId : node.toIds){
				allNode.get(toId).fromIds.add(node.id);
			}
		}
		for(StateNode node : allNode.values()){
			ArrayList<StateNode> toNodes = new ArrayList<StateNode>();
			ArrayList<StateNode> fromNodes = new ArrayList<StateNode>();
			for(long toId : node.toIds){
				toNodes.add(allNode.get(toId));
			}
			for(long fromId : node.fromIds){
				fromNodes.add(allNode.get(fromId));
			}
			node.initToAndFromNode(toNodes, fromNodes);
		}


	}

	private void updateNodeLooks(){
		for(StateNode node : allNode.values()){
			node.updateLooks();
		}
	}

	public void allNodeUnMark(){
		for(StateNode node : allNode.values()){
			node.unmark();
		}
	}

	public void allNodeColorMode(StateNode.ColorMode colorMode){
		for(StateNode node : allNode.values()){
			node.setColorMode(colorMode);
		}
		updateNodeLooks();
	}

}
