package lmntaleditor.stateviewer;

import lmntaleditor.*;

public class StatePainter extends Thread {
	private StateGraphPanel graphPanel;
	private boolean active;
	private boolean update;
	
	public StatePainter(StateGraphPanel stateGraphPanel){
		this.graphPanel = stateGraphPanel;
		this.active = false;
		this.update = false;
	}

	public void run(){
		while(true){
			if(active){
				if(update){
					update = false;
					graphPanel.repaint();
				}else{
					try {
						sleep(100);
					} catch (InterruptedException e) {
						FrontEnd.printException(e);
					}
				}
			}else{
				try {
					sleep(1000);
				} catch (InterruptedException e) {
					FrontEnd.printException(e);
				}
			}
		}
	}

	public void update(){
		update = true;
	}
	
	public void setActive(boolean active){
		this.active = active;
	}
	
	public boolean isActive(){
		return active;
	}
	
}