package lmntaleditor.stateviewer;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JPanel;
import lmntaleditor.*;

public class StatePanel extends JPanel{
	
	public StateGraphPanel stateGraphPanel;
	public StateControlPanel stateControlPanel;
	
	private String originalString;
	private boolean ltlmode;
	private StateNodeSet drawNodes;
	
	public StatePanel(){
		setLayout(new BorderLayout());
		
		stateGraphPanel = new StateGraphPanel(this);
		add(stateGraphPanel, BorderLayout.CENTER);
		
		stateControlPanel = new StateControlPanel(this);
		add(stateControlPanel, BorderLayout.SOUTH);
	}
	
	public void start(String str,boolean ltl){
		originalString = str;
		ltlmode = ltl;
		drawNodes = new StateNodeSet();
		boolean res;
		if(ltlmode){
			res = drawNodes.setSlimLtlResult(str);
		}else{
			res = drawNodes.setSlimNdResult(str);
		}
		
		if(res){
			stateGraphPanel.init(drawNodes);
			FrontEnd.mainFrame.toolTab.setTab("StateViewer");
			FrontEnd.println("(StateViewer) start! (state = "+drawNodes.size()+", depth = "+(drawNodes.getDepth()-1)+")");
		}else{
			FrontEnd.println("(StateViewer) error.");
		}
		
	}
	
	public void reset(){
		start(originalString,ltlmode);
	}
	
}
